#include <QtGui>

#include "nolocal.h"

double Atof (char* buff)
{
 // similar to atof but uses only decimal dots independent of the locale setting
 double res;
 QString s;

 s = buff;

 res = s.toDouble();

 return res;
}

void decdot (char* ntx)
{
  // commas in numbers into decimal dots in case some locale settings did it
  int j, lntx;
  bool b;  // no more substitutions if brackets are found

  b = true;
  lntx = strlen(ntx);
  for (j=0; j<lntx; j++)
   {
    if(ntx[j] == '(') b = false; 
    if(b && (ntx[j] == ',')) ntx[j] = '.';
   };
}

void decdot0 (char* ntx)
{
  // commas in numbers into decimal dots in case some locale settings did it
  int j, lntx;

  lntx = strlen(ntx);
  for (j=0; j<lntx; j++) if(ntx[j] == ',') ntx[j] = '.';
}

int Fscanf (FILE* fsfl, int numv, double *vard)
{
 // read a line with data (floating with decimal dot)
 // Return 1 if successful, 0 if problems

 char lbuf[81];
 char nbuf[81];
 int k, j, n1, n2, m, d;

 if (fgets(lbuf, 80, fsfl) == NULL) return 0;

 k = strlen(lbuf);
 if (k < 1) return 0;

 n1 = 0;
 for (j=0; j<numv; j++)
  {
   while ((n1 < k) && (lbuf[n1] == ' ')) n1++;
   if (n1 >= k) return 0;
   n2 = n1 + 1;
   while ((n2 < k) && (lbuf[n2] != ' ')) n2++;
   if (n2 > k) return 0;

   d = 0;
   for (m=n1; m<n2; m++)
    {
     nbuf[d] = lbuf[m];
     d++;
    };
   nbuf[d] = '\0';

   vard[j] = Atof(nbuf);
   n1 = n2;   
 };
 
 return 1;
}
