/********************************************************************************
********************************************************************************/

#ifndef STDATEDIALOG_H
#define STDATEDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>

class StDateDialog : public QDialog
{
  Q_OBJECT

public:
  StDateDialog();

public slots:
    virtual void setParams( int year, int month, int day, int hour, int minute, int second, double tzone, int tzauto, double dur, double rtoff );
    virtual void systemSlot();
    virtual void getParams( int & year, int & month, int & day, int & hour, int & minute, int & second, double & tzone, int & tzauto, double & dur, double & rtoff );

private:
    QLabel *textLabel1;
    QLineEdit *yearEdit;
    QLineEdit *monthEdit;
    QLineEdit *dayEdit;
    QLabel *textLabel2;
    QLabel *textLabel3;
    QLabel *textLabel4;
    QLabel *textLabel5;
    QLineEdit *hourEdit;
    QLineEdit *minEdit;
    QLineEdit *secEdit;
    QLabel *textLabel7;
    QCheckBox *systemBox;
    QLabel *textLabel8;
    QLineEdit *tzoneEdit;
    QPushButton *okButton;
    QPushButton *cancelButton;
    QLabel *textLabel9;
    QLineEdit *durEdit;
    QLabel *textLabel2_2;
    QLineEdit *rtEdit;
};
#endif // STDATEDIALOG_H
