/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stsysconfdialog.h"

StSysConfDialog::StSysConfDialog()
{
        setObjectName(QString::fromUtf8("StSysConfDialog"));
        resize(487, 368);
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(20, 10, 300, 20));
        textLabel1->setWordWrap(false);
        tolEdit = new QLineEdit(this);
        tolEdit->setObjectName(QString::fromUtf8("tolEdit"));
        tolEdit->setGeometry(QRect(20, 30, 140, 21));
        mxiEdit = new QLineEdit(this);
        mxiEdit->setObjectName(QString::fromUtf8("mxiEdit"));
        mxiEdit->setGeometry(QRect(20, 80, 100, 21));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(370, 10, 90, 29));
        okButton->setDefault(true);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(370, 40, 90, 29));
        liftEdit = new QLineEdit(this);
        liftEdit->setObjectName(QString::fromUtf8("liftEdit"));
        liftEdit->setGeometry(QRect(330, 110, 104, 21));
        textLabel1_3 = new QLabel(this);
        textLabel1_3->setObjectName(QString::fromUtf8("textLabel1_3"));
        textLabel1_3->setGeometry(QRect(330, 90, 140, 20));
        textLabel1_3->setWordWrap(false);
        dragEdit = new QLineEdit(this);
        dragEdit->setObjectName(QString::fromUtf8("dragEdit"));
        dragEdit->setGeometry(QRect(20, 320, 104, 21));
        textLabel7 = new QLabel(this);
        textLabel7->setObjectName(QString::fromUtf8("textLabel7"));
        textLabel7->setGeometry(QRect(20, 300, 130, 20));
        textLabel7->setWordWrap(false);
        crEdit = new QLineEdit(this);
        crEdit->setObjectName(QString::fromUtf8("crEdit"));
        crEdit->setGeometry(QRect(160, 320, 104, 21));
        textLabel6 = new QLabel(this);
        textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
        textLabel6->setGeometry(QRect(20, 280, 240, 20));
        textLabel6->setWordWrap(false);
        textLabel8 = new QLabel(this);
        textLabel8->setObjectName(QString::fromUtf8("textLabel8"));
        textLabel8->setGeometry(QRect(160, 300, 160, 20));
        textLabel8->setWordWrap(false);
        amEdit = new QLineEdit(this);
        amEdit->setObjectName(QString::fromUtf8("amEdit"));
        amEdit->setGeometry(QRect(330, 320, 130, 21));
        textLabel9 = new QLabel(this);
        textLabel9->setObjectName(QString::fromUtf8("textLabel9"));
        textLabel9->setGeometry(QRect(330, 300, 150, 20));
        textLabel9->setWordWrap(false);
        textLabel2 = new QLabel(this);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setGeometry(QRect(20, 120, 290, 20));
        textLabel2->setWordWrap(false);
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(20, 140, 190, 20));
        textLabel3->setWordWrap(false);
        fb107Edit = new QLineEdit(this);
        fb107Edit->setObjectName(QString::fromUtf8("fb107Edit"));
        fb107Edit->setGeometry(QRect(20, 160, 104, 21));
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(220, 140, 190, 20));
        textLabel4->setWordWrap(false);
        f107Edit = new QLineEdit(this);
        f107Edit->setObjectName(QString::fromUtf8("f107Edit"));
        f107Edit->setGeometry(QRect(220, 160, 104, 21));
        sunBox = new QCheckBox(this);
        sunBox->setObjectName(QString::fromUtf8("sunBox"));
        sunBox->setGeometry(QRect(270, 190, 190, 21));
        moonBox = new QCheckBox(this);
        moonBox->setObjectName(QString::fromUtf8("moonBox"));
        moonBox->setGeometry(QRect(270, 220, 190, 21));
        refractBox = new QCheckBox(this);
        refractBox->setObjectName(QString::fromUtf8("refractBox"));
        refractBox->setGeometry(QRect(270, 250, 190, 21));
        textLabel1_2 = new QLabel(this);
        textLabel1_2->setObjectName(QString::fromUtf8("textLabel1_2"));
        textLabel1_2->setGeometry(QRect(20, 60, 280, 20));
        textLabel1_2->setWordWrap(false);
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(20, 190, 230, 20));
        textLabel5->setWordWrap(false);
        kpEdit = new QLineEdit(this);
        kpEdit->setObjectName(QString::fromUtf8("kpEdit"));
        kpEdit->setGeometry(QRect(20, 210, 104, 21));
        atxBox = new QCheckBox(this);
        atxBox->setObjectName(QString::fromUtf8("atxBox"));
        atxBox->setGeometry(QRect(270, 280, 190, 21));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(tolEdit);
        textLabel1_3->setBuddy(liftEdit);
        textLabel7->setBuddy(dragEdit);
        textLabel8->setBuddy(crEdit);
        textLabel9->setBuddy(amEdit);
        textLabel3->setBuddy(fb107Edit);
        textLabel4->setBuddy(f107Edit);
        textLabel1_2->setBuddy(mxiEdit);
        textLabel5->setBuddy(kpEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(tolEdit, mxiEdit);
        QWidget::setTabOrder(mxiEdit, fb107Edit);
        QWidget::setTabOrder(fb107Edit, f107Edit);
        QWidget::setTabOrder(f107Edit, kpEdit);
        QWidget::setTabOrder(kpEdit, dragEdit);
        QWidget::setTabOrder(dragEdit, crEdit);
        QWidget::setTabOrder(crEdit, amEdit);
        QWidget::setTabOrder(amEdit, liftEdit);
        QWidget::setTabOrder(liftEdit, sunBox);
        QWidget::setTabOrder(sunBox, moonBox);
        QWidget::setTabOrder(moonBox, refractBox);
        QWidget::setTabOrder(refractBox, atxBox);
        QWidget::setTabOrder(atxBox, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));

        setWindowTitle(QApplication::translate("StSysConfDialog", "Configure System Parameters", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel1->setToolTip(QApplication::translate("StSysConfDialog", "Integration Tolerance.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel1->setWhatsThis(QApplication::translate("StSysConfDialog", "Needed for the numeric propagation. A smaller tolerance will force a smaller step size.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel1->setText(QApplication::translate("StSysConfDialog", "Relative &Tolerance for Numeric Integration: ", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StSysConfDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StSysConfDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StSysConfDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StSysConfDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel1_3->setToolTip(QApplication::translate("StSysConfDialog", "Lift to Drag Ratio", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel1_3->setWhatsThis(QApplication::translate("StSysConfDialog", "Used for numeric integration of the reentry orbit for altitudes < 90 km.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel1_3->setText(QApplication::translate("StSysConfDialog", "L&ift/Drag Ratio", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel7->setToolTip(QApplication::translate("StSysConfDialog", "CD coefficient", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel7->setWhatsThis(QApplication::translate("StSysConfDialog", "Typical values are 1.5 - 3.0.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel7->setText(QApplication::translate("StSysConfDialog", "&Drag Coefficient:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel6->setToolTip(QApplication::translate("StSysConfDialog", "S/C specific parameters.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel6->setWhatsThis(QApplication::translate("StSysConfDialog", "Needed for drag and solar radiation pressure.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel6->setText(QApplication::translate("StSysConfDialog", "Default S/C Parameters:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel8->setToolTip(QApplication::translate("StSysConfDialog", "Radiation Pressure Coefficient CR.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel8->setWhatsThis(QApplication::translate("StSysConfDialog", "Typical values are 1.2 - 1.9.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel8->setText(QApplication::translate("StSysConfDialog", "&Radiation Pressure:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel9->setToolTip(QApplication::translate("StSysConfDialog", "Area to mass ratio.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel9->setWhatsThis(QApplication::translate("StSysConfDialog", "Cross-sectional area divided by S/C mass.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel9->setText(QApplication::translate("StSysConfDialog", "&Area/Mass(m^2/kg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel2->setToolTip(QApplication::translate("StSysConfDialog", "Solar Flux and Geomagnetic Index.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel2->setWhatsThis(QApplication::translate("StSysConfDialog", "These parameters are needed for calculating atmospheric drag.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel2->setText(QApplication::translate("StSysConfDialog", "Default Space Weather Parameters:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel3->setToolTip(QApplication::translate("StSysConfDialog", "90 day F10.7 Flux.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel3->setWhatsThis(QApplication::translate("StSysConfDialog", "90 day average of the F10.7 solar flux value. Typical values are 70 for solar minumum and 240 for solar maximum.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel3->setText(QApplication::translate("StSysConfDialog", "Average Solar &Flux (F10.7):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel4->setToolTip(QApplication::translate("StSysConfDialog", "Daily F10.7 solar flux.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel4->setWhatsThis(QApplication::translate("StSysConfDialog", "Daily F10.7 solar flux value. Typical values are 70 for solar minumum and 330 for maximum.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel4->setText(QApplication::translate("StSysConfDialog", "Daily Solar Flux (F&10.7):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        sunBox->setToolTip(QApplication::translate("StSysConfDialog", "Include gravitational field of the Sun", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        sunBox->setWhatsThis(QApplication::translate("StSysConfDialog", "Always mark this except for special tests.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        sunBox->setText(QApplication::translate("StSysConfDialog", "&Solar perturbations", 0, QApplication::UnicodeUTF8));
        sunBox->setShortcut(QApplication::translate("StSysConfDialog", "Alt+S", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        moonBox->setToolTip(QApplication::translate("StSysConfDialog", "Include gravity field of the Moon.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        moonBox->setWhatsThis(QApplication::translate("StSysConfDialog", "Always keep this marked except for special tests.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        moonBox->setText(QApplication::translate("StSysConfDialog", "&Lunar perturbations", 0, QApplication::UnicodeUTF8));
        moonBox->setShortcut(QApplication::translate("StSysConfDialog", "Alt+L", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        refractBox->setToolTip(QApplication::translate("StSysConfDialog", "Correct elevation for refraction.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        refractBox->setWhatsThis(QApplication::translate("StSysConfDialog", "If marked a standard correction for refraction will be applied to the satellite elevation.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        refractBox->setText(QApplication::translate("StSysConfDialog", "Refractio&n ", 0, QApplication::UnicodeUTF8));
        refractBox->setShortcut(QApplication::translate("StSysConfDialog", "Alt+N", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel1_2->setToolTip(QApplication::translate("StSysConfDialog", "Maximum number of iterations for one integration step.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel1_2->setWhatsThis(QApplication::translate("StSysConfDialog", "If this number is exceeded during one integration step, this step will be forced even if the tolerance is not reached. If set to 0 the tolerance will always be respected but this can lead to an almost endless loop in case of a very bad condition.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel1_2->setText(QApplication::translate("StSysConfDialog", "&Maximum Number of Iterations:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel5->setToolTip(QApplication::translate("StSysConfDialog", "Geomagnetic K-index.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel5->setWhatsThis(QApplication::translate("StSysConfDialog", "Typical values are 0 for solar minumum and 8 for solar maximum.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel5->setText(QApplication::translate("StSysConfDialog", "Geomagnetic &Kp Index:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        atxBox->setToolTip(QApplication::translate("StSysConfDialog", "Correct for atmospheric extinction", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        atxBox->setWhatsThis(QApplication::translate("StSysConfDialog", "Perform a standard correction for atmospheric extinction for the magnitude calculation if the elevation is < 33 deg.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        atxBox->setText(QApplication::translate("StSysConfDialog", "E&xtinction", 0, QApplication::UnicodeUTF8));
        atxBox->setShortcut(QApplication::translate("StSysConfDialog", "Alt+X", 0, QApplication::UnicodeUTF8));
};

void StSysConfDialog::setParams( double RKFtol, double dF107, double dFB107, double dKp, double dCd, double dCr, double dAm, double lift, bool sunf, bool moonf , bool refrc, int mxit, bool atmx)
{
 QString s;
 
 s.setNum(RKFtol);
 tolEdit->setText(s);
 s.setNum(mxit);
 mxiEdit->setText(s);
 s.setNum(dF107);
 f107Edit->setText(s);
 s.setNum(dFB107);
 fb107Edit->setText(s);
 s.setNum(dKp);
 kpEdit->setText(s);
 s.setNum(dCd);
 dragEdit->setText(s);
 s.setNum(dCr);
 crEdit->setText(s);
 s.setNum(dAm);
 amEdit->setText(s);
 s.setNum(lift);
 liftEdit->setText(s);
 sunBox->setChecked(sunf);
 moonBox->setChecked(moonf);
 refractBox->setChecked(refrc);
 atxBox->setChecked(atmx);
}

void StSysConfDialog::getParams( double & RKFtol, double & dF107, double & dFB107, double & dKp, double & dCd, double & dCr, double & dAm, double& lift, bool& sunf, bool& moonf, bool& refrc, int& mxit, bool& atmx )
{
 QString s;

 s=tolEdit->text();
 RKFtol = s.toDouble();
 s=mxiEdit->text();
 mxit = s.toInt();
 s=f107Edit->text();
 dF107 = s.toDouble();
 s=fb107Edit->text();
 dFB107 = s.toDouble();
 s=kpEdit->text();
 dKp = s.toDouble();
 s=dragEdit->text();
 dCd = s.toDouble();
 s=crEdit->text();
 dCr = s.toDouble();
 s=amEdit->text();
 dAm = s.toDouble();
 s=liftEdit->text();
 lift = s.toDouble();
 sunf = sunBox->isChecked();
 moonf = moonBox->isChecked();
 refrc = refractBox->isChecked();
 atmx = atxBox->isChecked();
}
