/********************************************************************************
********************************************************************************/

#ifndef PICASTDIALOG_H
#define PICASTDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>

class StAstDialog : public QDialog
{
   Q_OBJECT

public:
   StAstDialog();

public slots:
   void setParams( double ra, double dec );
   void getParams( double &ra, double &dec, bool &abort );
   void abortSlot();

private:  
    QLabel *label_2;
    QLineEdit *raEdit;
    QLabel *label_3;
    QLineEdit *decEdit;
    QPushButton *cancelButton;
    QPushButton *abortButton;
    QPushButton *okButton;
    QLabel *label;
    bool pabort;

};

#endif // PICASTDIALOG_H
