/********************************************************************************
********************************************************************************/

#ifndef STSWITCHDIALOG_H
#define STSWITCHDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>

//QT_BEGIN_NAMESPACE

class StSwitchDialog : public QDialog
{
  Q_OBJECT

public:
   StSwitchDialog();

public slots:
    virtual void setParams( int prs, int rlm, int satn );
    virtual void getParams( int & prs, int & rlm );

private:
    QGroupBox *buttonGroup1;
    QRadioButton *satButton1;
    QRadioButton *satButton2;
    QRadioButton *satButton3;
    QRadioButton *satButton4;
    QRadioButton *satButton5;
    QRadioButton *satButton6;
    QRadioButton *satButton7;
    QRadioButton *satButton8;
    QRadioButton *satButton9;
    QRadioButton *satButton10;
    QCheckBox *relativeBox;
    QPushButton *closeButton;

};

#endif // STSWITCHDIALOG_H
